//+------------------------------------------------------------------+
//|                                                     iMACross.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
//---- input parameters

/*
           .
*/

extern int FastMAPeriod =  5;    //   
extern int FastMAMethod =  0;    //   : 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int FastMAPrice  =  4;    //   : 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern int FastMAShift  =  0;    //   
extern int SlowMAPeriod =  34;   //   
extern int SlowMAMethod =  0;    //   : 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int SlowMAPrice  =  4;    //   : 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern int SlowMAShift  =  0;    //   

//---- buffers
double up[];
double dn[];
double pt;
int drb;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){  
   pt=Point*PTA(Period());
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,up);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,dn);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   
   drb=1+MathMax(fMADrawBegin(FastMAPeriod,FastMAMethod)+FastMAShift,fMADrawBegin(SlowMAPeriod,SlowMAMethod)+SlowMAShift);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=MathMin(Bars-IndicatorCounted(),Bars-drb);

            for(int i=limit-1;i>=0;i--){
               double fast_ma0=iMA(NULL,0,FastMAPeriod,0,FastMAMethod,FastMAPrice,i+FastMAShift);
               double slow_ma0=iMA(NULL,0,SlowMAPeriod,0,SlowMAMethod,SlowMAPrice,i+SlowMAShift);
               double fast_ma1=iMA(NULL,0,FastMAPeriod,0,FastMAMethod,FastMAPrice,i+1+FastMAShift);
               double slow_ma1=iMA(NULL,0,SlowMAPeriod,0,SlowMAMethod,SlowMAPrice,i+1+SlowMAShift);
               up[i]=0;
               dn[i]=0;
               
                  if(fast_ma0>slow_ma0){
                     if(fast_ma1<=slow_ma1){
                        up[i]=Low[i]-pt;     
                     }
                  }
                  if(fast_ma0<slow_ma0){
                     if(fast_ma1>=slow_ma1){
                        dn[i]=High[i]+pt;  
                     }
                  }
             
               
            }

   return(0);
}
int PTA(int aPeriod){
      switch(aPeriod){
         case PERIOD_M1:
            return(4);
         case PERIOD_M5:
            return(6);
         case PERIOD_M15:
            return(8);
         case PERIOD_M30:
            return(13);             
         case PERIOD_H1:
            return(17);  
         case PERIOD_H4:
            return(40);  
         case PERIOD_D1:
            return(70);                   
         case PERIOD_W1:
            return(150); 
         case PERIOD_MN1:
            return(300);          
      }
   return(5);
}

int fMADrawBegin(int aPeriod,int aMethod){
      switch(aMethod){
         case 1: return(10*aPeriod);
         case 2: return(20*aPeriod);      
      }
   return(aPeriod);    
}

